﻿using System;
using System.Threading;
using System.Windows.Forms;

namespace Click_Game
{
    public partial class Frm : Form
    {
        string clickedMsg = "Clicked!";


        int initInterval = 90;
        int round = 0;
        bool isRoundActive = false;
        bool[] clicked = new bool[9];

        public Frm()
        {
            InitializeComponent();
            clearClicked();
        }

        bool checkClicked(int range)
        {
            if (!isRoundActive)
                return false;
            for (int i = 0; i < range; i++)
            {
                if (!clicked[i])
                    return false;
            }
            return true;
        }

        void clearClicked()
        {
            for (int i = 0; i < clicked.Length; i++)
            {
                clicked[i] = false;
            }
        }

        void disableButton(Button btn)
        {
            btn.Text = clickedMsg;
            btn.Enabled = false;
        }

        void nextRound()
        {
            timer1.Enabled = false;
            round++;
            clearClicked();
            groupBox1.Text = "Round " + round.ToString();
            doNewButtons(initInterval);
            timer1.Interval = 3810 - (round * 400);
            isRoundActive = true;
            timer1.Start();
        }

        void doNewButtons(int interval)
        {
            button1.clear();
            Thread.Sleep(interval);
            button2.clear();
            Thread.Sleep(interval);
            button3.clear();
            Thread.Sleep(interval);
            button4.clear();
            Thread.Sleep(interval);
            button5.clear();
            Thread.Sleep(interval);
            button6.clear();
            Thread.Sleep(interval);
            button7.clear();
            Thread.Sleep(interval);
            button8.clear();
            Thread.Sleep(interval);
            button9.clear();
        }


        #region buttons
        private void button1_Click(object sender, EventArgs e)
        {
            if (isRoundActive)
            {
                clicked[0] = true;
                disableButton(button1);
            }
        }

        private void button2_Click(object sender, EventArgs e)
        {
            if (checkClicked(1))
            {
                clicked[1] = true;
                disableButton(button2);
            }
        }

        private void button3_Click(object sender, EventArgs e)
        {
            if (checkClicked(2))
            {
                clicked[2] = true;
                disableButton(button3);
            }
        }

        private void button4_Click(object sender, EventArgs e)
        {
            if (checkClicked(3))
            {
                clicked[3] = true;
                disableButton(button4);
            }
        }

        private void button5_Click(object sender, EventArgs e)
        {
            if (checkClicked(4))
            {
                clicked[4] = true;
                disableButton(button5);
            }
        }

        private void button6_Click(object sender, EventArgs e)
        {
            if (checkClicked(5))
            {
                clicked[5] = true;
                disableButton(button6);
            }
        }

        private void button7_Click(object sender, EventArgs e)
        {
            if (checkClicked(6))
            {
                clicked[6] = true;
                disableButton(button7);
            }
        }

        private void button8_Click(object sender, EventArgs e)
        {
            if (checkClicked(7))
            {
                clicked[7] = true;
                disableButton(button8);
            }
        }

        private void button9_Click(object sender, EventArgs e)
        {
            if (checkClicked(8))
            {
                timer1.Enabled = false;
                clicked[8] = true;
                disableButton(button9);
                roundButton.Enabled = true;
                isRoundActive = false;
                MessageBox.Show("Round " + round.ToString() + " complete! Congratulations!", "Congratulations!");
            }
        }
        #endregion

        private void roundButton_Click(object sender, EventArgs e)
        {
            if (roundButton.Text != "Next Round")
                roundButton.Text = "Next Round";
            nextRound();
            roundButton.Enabled = false;
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            if (isRoundActive)
            {
                round = 0;
                isRoundActive = false;
                MessageBox.Show("YOU SUCK AT THIS GAME!", "GAME OVER");
                roundButton.Enabled = true;
                roundButton.Text = "Start Over";
            }
        }

        private void Frm_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == (char)27)
                Environment.Exit(0);
        }
    }

    public static class Helper
    {
        public static void clear(this Button btn)
        {
            btn.Text = btn.Name.Replace("button", "");
            btn.Enabled = true;
        }
    }
}
